<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <title>项目任务书</title>
    <link rel="stylesheet" th:href="@{/lib/layui/css/layui.css}" media="all">
    <link rel="stylesheet" th:href="@{/css/public.css}" media="all">
    <link rel="stylesheet" th:href="@{/lib/font-awesome-4.7.0/css/font-awesome.min.css}" media="all">
</head>
<body>
<div class="layuimini-container">
    <div class="layuimini-main">
        <fieldset class="table-search-fieldset">
            <legend>搜索信息(<b>收起-展开</b>)</legend>
            <div id="search-div" style="margin: 5px 10px -10px 0px">
                <form class="layui-form" action="" lay-filter="search-form">
                    <div class="layui-form-item">
                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px">中文名称</label>
                            <div class="layui-input-inline" style="width: 250px">
                                <input type="text" name="zwmc" id='zwmc' autocomplete="off" class="layui-input">
                            </div>
                        </div>

                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px">ERP编号</label>
                            <div class="layui-input-inline" style="width: 150px">
                                <input type="text" name="erpbh" id = 'erpbh' autocomplete="off" class="layui-input">
                            </div>
                        </div>

                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px">项目类型</label>
                            <div class="layui-input-inline" style="width: 150px">
                                <select name="xmlx" id="xmlx" lay-filter="status">
                                    <option value="">全部</option>
                                    <option th:each="item:${xmlxList}" th:text="${item.name}"
                                            th:value="${item.code}"></option>
                                </select>
                            </div>
                        </div>

                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px">审批状态</label>
                            <div class="layui-input-inline" style="width: 150px">
                                <select name="spzt" lay-filter="status">
                                    <option value="">全部</option>
                                    <option th:each="item:${dictList}" th:text="${item.name}"
                                            th:value="${item.name}"></option>
                                </select>
                            </div>
                        </div>

                        <div class="layui-inline" style="margin-left: 0px">
                            <button type="submit" class="layui-btn" lay-submit lay-filter="data-search-btn"><i
                                    class="layui-icon"></i> 搜 索
                            </button>
                            <button type="submit" class="layui-btn layui-btn-primary" lay-submit
                                    lay-filter="data-reset-btn"><i class="layui-icon layui-icon-refresh"></i> 重 置
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </fieldset>

        <script type="text/html" id="toolbarDemo">
            <div class="layui-btn-container">
               <!-- <button class="layui-btn layui-btn-sm data-add-btn" lay-event="add">
                    <i class="layui-icon layui-icon-addition" style="font-size: 10px;"></i>新增
                </button>-->
                <button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="edit">
                    <i class="layui-icon layui-icon-edit" style="font-size: 10px;"></i>编辑
                </button>
                <button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="view">
                    <i class="layui-icon layui-icon-file" style="font-size: 10px;"></i>查看
                </button>
               <!-- <button class="layui-btn layui-btn-sm layui-btn-danger" lay-event="delete">
                    <i class="layui-icon layui-icon-delete" style="font-size: 10px;"></i>删除
                </button>-->
               <!-- <button class="layui-btn layui-btn-sm data-add-btn" lay-event="tjApprove">
                    <i class="layui-icon layui-icon-ok" style="font-size: 10px;"></i>提交审批
                </button>-->
                <button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="spOption">
                    <i class="layui-icon layui-icon-edit" style="font-size: 10px;"></i>审核
                </button>
                <button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="spList">
                    <i class="layui-icon layui-icon-list" style="font-size: 10px;"></i>审批列表
                </button>
                <button class="layui-btn layui-btn-sm" lay-event="downloadWord">
                    <i class="layui-icon layui-icon-export" style="font-size: 10px;"></i>导出
                </button>
               <!-- <button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="Xgsq">
                    <i class="layui-icon layui-icon-file" style="font-size: 10px;"></i>修改申请
                </button>-->

                <!--                <button class="layui-btn layui-btn-sm" lay-event="exportExcel">-->
                <!--                    <i class="layui-icon layui-icon-export" style="font-size: 10px;"></i>导出列表-->
                <!--                </button>-->
            </div>
        </script>

        <input type="hidden" id="userId" name="userId" class="layui-input" th:value="${userId}">
        <table class="layui-hide" id="currentTableId" lay-filter="currentTableFilter"></table>

        <!--        <script type="text/html" id="currentTableBar">-->
        <!--            <a class="layui-btn layui-btn-xs layui-btn-warm data-count-view" lay-event="view">-->
        <!--                <i class="layui-icon layui-icon-set" style="font-size: 10px;"></i>查看-->
        <!--            </a>-->
        <!--            <a class="layui-btn layui-btn-xs data-count-update" lay-event="update">-->
        <!--                <i class="layui-icon layui-icon-edit" style="font-size: 10px;"></i>编辑-->
        <!--            </a>-->
        <!--            <a class="layui-btn layui-btn-xs layui-btn-danger data-count-delete" lay-event="delFlag">-->
        <!--                <i class="layui-icon layui-icon-delete" style="font-size: 10px;"></i>删除-->
        <!--            </a>-->
        <!--        </script>-->
    </div>
</div>

<script>

    // 获取所有需要去除空格的输入框
    const inputs = [
        document.getElementById('zwmc'),
        document.getElementById('erpbh'),

    ];
    // 为每个输入框添加事件监听
    inputs.forEach(input => {
        input.addEventListener('input', function() {
            this.value = this.value.replace(/\s+/g, ''); // 去除空格
        });
    });


</script>
<script th:src="@{/lib/jquery-3.4.1/jquery-3.4.1.min.js}" charset="utf-8"></script>
<script th:src="@{/lib/layui/layui.js}" charset="utf-8"></script>
<script th:src="@{/lib/coco-message/coco-message.js}" charset="utf-8"></script>
<script th:src="@{/js/lay-config.js}" charset="utf-8"></script>
<script th:src="@{/lib/xm-select-v1.2.2/xm-select.js}" charset="utf-8"></script>
<script th:inline="javascript" type="text/javascript">
    AjaxUtil.ctx = /*[[@{/}]]*/'';
    var updateflag = 0;
    var xmApproval = {};
    layui.use(['form', 'table'], function () {
        var form = layui.form,
            table = layui.table;
        var userId = $("#userId").val();

        var currTable = table.render({
            elem: '#currentTableId',
            url: AjaxUtil.ctx + 'prjProject/list_deptproject',
            method: 'post',
            toolbar: '#toolbarDemo',
            defaultToolbar: ['filter', 'exports', 'print'],
            cols: [
                [
                    {type: "checkbox", fixed: 'left'},
                    {type: 'numbers', align: 'center',title: '序号'},
                    {field: 'zwmc', width: '26%', title: '中文名称'},
                    {field: 'spzt', width: '10%', title: '审批状态', sort: true},
                    {field: 'erpbh', width: '10%', title: 'ERP编号'},
                    {field: 'jf',width: '7%' ,title: '子课题经费(元)' ,align: 'right',templet:function (row) {
                        if (row.jf != null){
                            return row.jf.toLocaleString(undefined,{maximumFractionDigits:2,minimumFractionDigits:2});
                        }
                        return '0.00';
                        }},
                    {field: 'czze', width: '7%',title: '出资总额(元)', align: 'right',templet:function (row) {
                        if (row.czze != null){
                            return row.czze.toLocaleString(undefined,{maximumFractionDigits: 2,minimumFractionDigits: 2});
                        }
                        return '0.00';
                        }},
                    {field: 'sqze',width: '7%',title: '申请总额(元)',align: 'right',templet:function (row) {
                        if (row.sqze != null){
                            return row.sqze.toLocaleString(undefined,{maximumFractionDigits:2,minimumFractionDigits:2});
                        }
                        return '0.00';

                        }},
                    {field: 'bzze', width: '7%', title: '报账总额(元)',align: 'right',templet:function (row) {
                            if (row.bzze != null){
                                return row.bzze.toLocaleString(undefined,{maximumFractionDigits:2,minimumFractionDigits:2});
                            }
                            return '0.00';
                        }},
                    {field: 'yfze',width: '7%',title: '已付总额(元)',align: 'right',templet:function (row) {
                        if(row.yfze != null){
                            return row.yfze.toLocaleString(undefined,{maximumFractionDigits:2,minimumFractionDigits:2});
                        }
                        return '0.00';

                        }},
                    {field: 'xmlxmc', width: '15%', title: '项目类型'},
                    {field: 'qs', width: '8%', title: '起始', align: 'center'},
                    {field: 'wc', width: '8%', title: '完成', align: 'center'},
                    {field: 'cjrxm', width: '7%', title: '创建人', align: 'center'},
                    {field: 'cjrq', width: '8%', title: '创建时间', align: 'center'}
                    // {title: '操作', toolbar: '#currentTableBar', align: 'center', fixed: 'right'}
                ]
            ],
            autoSort: false,
            limits: [10, 15, 20, 25, 50, 100],
            limit: 10,
            page: true,
            skin: 'grid',
            parseData: function (res) { //res 即为原始返回的数据
                return {
                    "code": res.code, //解析接口状态
                    "msg": res.message, //解析提示文本
                    "count": res.data.total, //解析数据长度
                    "data": res.data.rows //解析数据列表
                };
            },
            done: function (res, curr, count) { // done为数据渲染完的回调
                // 测试打印出后端返回的权限列表
                // let permissionSet = [[${permissionSet}]];
                // console.log(JSON.stringify(permissionSet));
            }
        });

        // 监听搜索操作
        form.on('submit(data-search-btn)', function (data) {
            // 执行搜索重载
            currTable.reload({
                page: {
                    curr: 1 // 页码从1开始
                },
                where: form.val("search-form")
            });
            return false;
        });

        // 监听重置操作
        form.on('submit(data-reset-btn)', function (data) {
            form.val("search-form", {
                "zwmc": '',
                "erpbh": '',
                "xmlx": '',
                "spzt": ''
            });
            // 执行搜索重载
            currTable.reload({
                page: {
                    curr: 1
                },
                where: form.val("search-form")
            });
            return false;
        });

        // 监听排序事件
        table.on('sort(currentTableFilter)', function (obj) { //注：sort 是工具条事件名，test 是 table 原始容器的属性 lay-filter="对应的值"
            // console.log(obj.field); //当前排序的字段名
            // console.log(obj.type); //当前排序类型：desc（降序）、asc（升序）、null（空对象，默认排序）
            // console.log(this); //当前排序的 th 对象
            //尽管我们的 table 自带排序功能，但并没有请求服务端。
            //有些时候，你可能需要根据当前排序的字段，重新向服务端发送请求，从而实现服务端排序，如：
            currTable.reload({
                initSort: obj, //记录初始排序，如果不设的话，将无法标记表头的排序状态。
                where: { //请求参数（注意：这里面的参数可任意定义，并非下面固定的格式）
                    sortName: toLine(obj.field), //排序字段
                    sortOrder: toLine(obj.type) //排序方式
                }
            });
        });

        // 监听行工具事件
        table.on('toolbar(currentTableFilter)', function (obj) {
            if (obj.event === 'add') {  // 监听添加操作
                layer.open({
                    title: '新建项目任务书',
                    type: 2,
                    shade: 0.3,
                    maxmin: true,
                    area: ['1090px', layerheight + 'px'],
                    content: AjaxUtil.ctx + 'prjProject/forAdd',
                    end: function (index) {
                        // 重载表格
                        if (updateflag == 1)
                            currTable.reload();
                        updateflag = 0;
                    }
                });
                // layer.full(index);
            } else if (obj.event == 'edit') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要编辑的任务书！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行编辑操作！", 1500);
                } else if (data[0].spzt == "审批结束") {
                    Message.warning("该任务书已审批结束，不能修改！", 1500);
                } else if (data[0].spzt != null && data[0].spzt.indexOf("未提交") < 0) {
                    Message.warning("该任务书审批中，不能修改！", 1500);
                } else if (data[0].cjr != userId) {
                    Message.error("您不是该任务书的创建人！", 1500);
                } else {
                    console.log("修改项目任务书");
                    layer.open({
                        title: '修改项目任务书',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1090px', layerheight + 'px'],
                        content: AjaxUtil.ctx + 'prjProject/forUpdate/' + data[0].id,
                        end: function (index) {
                            if (updateflag == 1)
                                currTable.reload();
                            updateflag = 0;
                        }
                    });
                    // layer.full(index);
                }
            } else if (obj.event == 'view') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要查看的任务书！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行查看！", 1500);
                } else {
                    layer.open({
                        title: '查看项目任务书',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1090px', layerheight + 'px'],
                        content: AjaxUtil.ctx + 'prjProject/forView/' + data[0].id,
                        end: function (index) {
                            layer.close(index);
                        }
                    });
                    // layer.full(index);
                }
            } else if (obj.event === 'delete') {  // 监听删除操作
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要删除的任务书！", 1000);
                    return;
                } else {
                    for (let item of data) {
                        if (item.cjr != userId) {
                            Message.error("存在您不是创建人的任务书，不能直接删除！", 2000);
                            return;
                        }
                        if (item.spzt != "未提交") {
                            if (item.spzt == "审批结束")
                                Message.warning("存在已审批结束的可研报告，不能直接删除！", 2000);
                            else if (data[0].spzt != null)
                                Message.warning("存在审批中的可研报告，不能直接删除！", 2000);
                            return;
                        }
                    }
                }
                layer.confirm('确定批量删除项目任务书吗？', function (index) {
                    layer.close(index);
                    AjaxUtil.post({
                        url: AjaxUtil.ctx + "prjProject/batchDelete",
                        contentType: "application/json",
                        data: JSON.stringify(data),
                        success: function (res) {
                            if (res.code === 0) {
                                Message.success(1500, res.message, function () {
                                    // 重载表格
                                    currTable.reload();
                                });
                            } else {
                                Message.error(res.message, 1000);
                            }
                        },
                        error: function (error) {
                        }
                    });
                });
            } else if (obj.event === 'exportExcel') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                let a = document.createElement('a');
                a.href = AjaxUtil.ctx + 'prjProject/exportExcel';
                a.click();
                a.parentNode.removeChild(a);
            } else if (obj.event === 'tjApprove') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要提交审批的任务书！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行提交！", 1500);
                } else if (data[0].spzt == "审批结束") {
                    Message.warning("该任务书已审批结束！", 1500);
                } else if (data[0].spzt != null && data[0].spzt.indexOf("未提交") < 0) {
                    Message.warning("该任务书正在审批中……", 1500);
                } else if (data[0].cjr != userId) {
                    Message.error("您不是该任务书的创建人！", 1500);
                } else {
                    xmApproval = {
                        "xmid": data[0].id,
                        "xm": data[0].zwmc,
                        "zt": data[0].spzt
                    };
                    if (data[0].spzt == null) {
                        xmApproval.zt = "未提交";
                        data[0].spzt = "未提交";
                    }

                    var content = AjaxUtil.ctx + 'prjProject/forApproveAdd';
                    if (data[0].spzt != "未提交")
                        // content = AjaxUtil.ctx + 'prjProject/forApproveUpdate/' + data[0].id + '?spzt=' + data[0].spzt;
                        content = AjaxUtil.ctx + 'prjProject/forApproveUpdate/' + data[0].id + '/' + data[0].ysje + '?spzt=' + data[0].spzt;

                    layer.open({
                        title: '提交审批',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1025px', layerheight + 'px'],
                        content: content,
                        end: function (index) {
                            if (updateflag == 1)
                                currTable.reload();
                            updateflag = 0;
                        }
                    });
                }
            } else if (obj.event === 'spOption') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要审批的任务书！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行审批！", 1500);
                } else if (data[0].spzt == null || data[0].spzt.indexOf("未提交") >= 0) {
                    Message.warning("该任务书尚未提交审批！", 1500);
                } else if (data[0].spzt == "审批结束") {
                    Message.warning("该任务书已审批结束！", 1500);
                } else {

                    // 判断当前人员是否是审核人
                    AjaxUtil.get({
                        url: AjaxUtil.ctx + "prjAnnualbudget/getshr?xmid="+data[0].id+'&spzt='+data[0].spzt,
                        contentType: "application/json",
                        success: function (res) {
                            if (res.code === -1) {
                                layer.msg(res.message,{icon:2});
                                return;
                            } else if (res.code === -2){
                                layer.msg(res.message,{icon:2});
                                return;
                            }else {
                                xmApproval = {
                                    "xmid": data[0].id,
                                    "xm": data[0].zwmc,
                                    "ysje": data[0].ysje
                                };

                                layer.open({
                                    title: '审批意见',
                                    type: 2,
                                    shade: 0.3,
                                    maxmin: true,
                                    shadeClose: true,
                                    area: ['1025px', layerheight + 'px'],
                                    content: AjaxUtil.ctx + 'prjProject/forApproveUpdate/' + data[0].id + '/' + data[0].ysje + '?spzt=' + data[0].spzt,
                                    end: function (index) {
                                        if (updateflag == 1)
                                            currTable.reload();
                                        updateflag = 0;
                                    }
                                });
                            }
                        },
                        error: function (error) {
                        }
                    });

                }
            } else if (obj.event === 'spList') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要查看审批列表的任务书！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行查看！", 1500);
                } else if (data[0].spzt == null || data[0].spzt == "未提交") {
                    Message.warning("该任务书尚未提交审批！", 1500);
                } else {
                    xmApproval = {
                        "xmid": data[0].id,
                        "xm": data[0].zwmc
                    };
                    var index = layer.open({
                        title: '审批列表',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1300px', layerheight + 'px'],
                        content: AjaxUtil.ctx + 'prjProject/forApproveList',
                        end: function () {
                            layer.close(index);
                        }
                    });
                }
            } else if (obj.event === 'downloadWord') {  // 监听查看操作
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要导出的任务书！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行导出！", 1500)
                } else {
                    layer.confirm('是否确定导出任务书——' + data[0].zwmc + '？', {
                        btn: ['导出', '取消']
                    }, function (index, layero) {
                        window.location.href = AjaxUtil.ctx + "prjProject/exportWord/" + data[0].id;
                        layer.close(index);

                    }, function (index) {

                    });
                }
            }else if (obj.event == 'Xgsq') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;


                if (data == null || data.length === 0) {
                    Message.warning("请选择要编辑的任务书！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行编辑操作！", 1500);
                }else if(data[0].spzt != '审批结束'){
                    Message.warning("该功能需在审批结束后使用！", 1500);
                } else {

                    console.log("修改项目任务书");
                    layer.open({
                        title: '修改项目任务书',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1090px', layerheight + 'px'],
                        content: AjaxUtil.ctx + 'prjProject/forXgUpdate/' + data[0].id,
                        success: function (layero, index) {

                        },
                        end: function (index) {
                            if (updateflag == 1)
                                currTable.reload();
                            updateflag = 0;
                        }
                    });
                    // layer.full(index);
                }
            }
        });

        //双击
        table.on('rowDouble(currentTableFilter)', function (obj) {
            var data = obj.data;
            layer.open({
                title: '查看项目任务书',
                type: 2,
                shade: 0.3,
                maxmin: true,
                shadeClose: true,
                area: ['1090px', layerheight + 'px'],
                content: AjaxUtil.ctx + 'prjProject/forView/' + data.id,
                end: function (index) {
                    layer.close(index);
                }
            });
            // layer.full(index);
        });
    });

    function setUpdateFlag() {
        updateflag = 1;
    }

    function getXmApproval() {
        return xmApproval;
    }
</script>
</body>
</html>